﻿
if(not GQ) then
GQ = {}
GQ.frame = CreateFrame("Frame");
GQ.emblems = {
	[47241] = 0, -- triumph
	[45624] = 0, -- conquest
	[40753] = 0, -- valor
	[40752] = 0, -- heroism
  }
GQ.gems = {
	["red"] = "36919", 
	["yellow"] = "36922", 
	["blue"] = "36925", 
	["orange"] = "36931", 
	["violet"] = "36928", 
	["green"] = "36934", 
  }
  GQ.convert = {
	[45624] = 0, -- conquest
	[40753] = 0, -- valor
	[40752] = 0, -- heroism
  }
  GQ.gemqueue = {
  	["red"] = 0, 
	["yellow"] = 0, 
	["blue"] = 0, 
	["orange"] = 0, 
	["violet"] = 0, 
	["green"] = 0, 
  }
  GQ.vendors = {
	"Magistrix Vesara", 
	"Magister Sarien", 
	"Magister Brasael", 
	"Magistrix Lambriesse", 
  }
  GQ.step = 0
  
  -- Debug Mode
  GQ.debug = false
  
end

function GQ.OnLoad()
SlashCmdList["GQ"] = GQ.Slash;
SLASH_GQ1 = "/gq";
SLASH_GQ2 = "/gemqueue";
GemQueueFormBuyButton:SetButtonState("DISABLED")
if GQ.debug then message("GemQueue: Debug mode ON") end
end

function GQ.Slash(cmd)
	if cmd ~= "" then
		if cmd == "abort" then 
            GQ.Reset()
            GQ.Refresh()
		else
			print("type /gq abort to abort when no frames are shown")
		end
	elseif cms == nil and GQ.step < 1 then 
		GemQueueForm:Show()
	end
end

function GQ.GetEmblemCount()
	for i=1, GetCurrencyListSize() do
		local name,_,_,_,_,count,_,_,itemID = GetCurrencyListInfo(i)
		for k, v in pairs(GQ.emblems) do
			if k == itemID then
				GQ.emblems[k] = count
			end
		end
	end	
end

function GQ.CheckVendor(value)
	for i=1, GetMerchantNumItems() do
		local name = GetMerchantItemInfo(i);
		
		if value == "conquest" then
			value = 45624
		elseif value == "valor" then
			value = 40753
		elseif value == "heroism" then
			value = 40752
		end
		
		for k, v in pairs(GQ.emblems) do
			local sName = GetItemInfo(k);
			if name == sName then 
				if value == k then
					return i
				end
			end
		end
		for k, v in pairs(GQ.gems) do
			local sName = GetItemInfo(v);
			if name == sName then 
				if value == k then
					return i
				end
			end
		end
	end
end

function GQ.GetPrice()
	local price = 0
	for k, v in pairs(GQ.gemqueue) do
		if k == "red" or k == "yellow" or k == "blue" then
			price = price + v * 20
		elseif k == "orange" or k == "violet" or k == "green" then
			price = price + v * 10
		end
	end
	return price
end

function GQ.ReadyConvert()
	local total = 0
	local conquest, valor, heroism, newprice
	GQ.GetEmblemCount()
		
	for k, v in pairs(GQ.emblems)do
		total = total + v
		if k == 45624 then
			conquest = v
		elseif k == 40753 then
			valor = v
		elseif k == 40752 then
			heroism = v
		end
	end
	
	if total < GQ.GetPrice() then
		message("not enough emblems! \n missing: "..GQ.GetPrice()-total)
		return false
	else
		newprice = GQ.GetPrice()
		newprice = newprice - heroism
		if newprice > 0 then 
			GQ.convert[40752] = newprice
		end
		newprice = newprice - valor
		if newprice > 0 then 
			GQ.convert[40753] = newprice
		end
		newprice = newprice - conquest
		if newprice > 0 then 
			GQ.convert[45624] = newprice
		end
	end
	
end

function GQ.AddGem(color)
    if color then
        GQ.gemqueue[color] = GQ.gemqueue[color] + 1
    end
	if GQ.ReadyConvert() == false then 
        GQ.gemqueue[color] = GQ.gemqueue[color] - 1
    end
	
	for k, v in pairs(GQ.gemqueue) do
		if v <= 0 then GQ.gemqueue[k] = 0 end
	end
    GQ.Refresh()
end

function GQ.DelGem(color)
    if color then
        GQ.gemqueue[color] = GQ.gemqueue[color] - 1
    end
	
	for k, v in pairs(GQ.gemqueue) do
		if v <= 0 then GQ.gemqueue[k] = 0 end
	end
    GQ.Refresh()
end

function GQ.Refresh()
	GemQueueFormPanel1RedCountLabel:SetText(GQ.gemqueue["red"])
	GemQueueFormPanel2YellowCountLabel:SetText(GQ.gemqueue["yellow"])
	GemQueueFormPanel3BlueCountLabel:SetText(GQ.gemqueue["blue"])
	GemQueueFormPanel4OrangeCountLabel:SetText(GQ.gemqueue["orange"])
	GemQueueFormPanel5VioletCountLabel:SetText(GQ.gemqueue["violet"])
	GemQueueFormPanel6GreenCountLabel:SetText(GQ.gemqueue["green"])
	
	GemQueueFormCountLabel:SetText("Emblems: "..GQ.GetPrice())
	
	if GQ.GetPrice() > 0 then 
		GemQueueFormBuyButton:SetButtonState("NORMAL")
	elseif GQ.GetPrice() == 0 then
		GQ.Reset()
	end
end

function GQ.Reset()
	for k, v in pairs(GQ.gemqueue) do
		GQ.gemqueue[k] = 0
	end
	GQ.step = 0
	GQ.frame:SetScript("OnEvent", nil);
	GQ.frame:UnregisterEvent("MERCHANT_SHOW")
	GQ.frame:UnregisterEvent("MERCHANT_UPDATE")
	GQ.frame:UnregisterEvent("MERCHANT_CLOSED")
	GemQueueProcess:Hide()
	GemQueueFormBuyButton:SetButtonState("DISABLED")
end

function GQ.Buy()
	if GQ.step == 1 then
		if GQ.convert[45624] > 0 then
			if GQ.CheckVendor("conquest") then
				if GQ.debug then
					print("buy: conquest id:".. GQ.CheckVendor("conquest").. " count:".. GQ.convert[45624])
				else
					BuyMerchantItem(GQ.CheckVendor("conquest"), GQ.convert[45624])
				end
				GQ.step = 2
			else
				return false
			end
		else
			GQ.step = 2
		end
	elseif  GQ.step == 2 then
		if GQ.convert[40753] > 0 then
			if GQ.CheckVendor("valor") then
				if GQ.debug then
					print("buy: valor id:".. GQ.CheckVendor("valor").. " count:".. GQ.convert[40753])
				else
					BuyMerchantItem(GQ.CheckVendor("valor"), GQ.convert[40753])
				end
				GQ.step = 3
			else
				return false
			end
		else 
			GQ.step = 3
		end
	elseif GQ.step == 3 then
		if GQ.convert[40752] > 0 then
			if GQ.CheckVendor("heroism") then
				if GQ.debug then
					print("buy: heroism id:".. GQ.CheckVendor("heroism").. " count:".. GQ.convert[40752])
				else
					BuyMerchantItem(GQ.CheckVendor("heroism"), GQ.convert[40752])
				end
				GQ.step = 4
			else
				return false
			end
		else 
			GQ.step = 4
		end
	elseif GQ.CheckVendor("red") and GQ.CheckVendor("yellow") and GQ.CheckVendor("blue") and GQ.CheckVendor("orange") and GQ.CheckVendor("violet") and GQ.CheckVendor("green") and GQ.step == 4 then
		for k, v in pairs(GQ.gemqueue) do
			if v > 0 and GQ.debug then
				print("buy: "..k.." id:".. GQ.CheckVendor(k).. " count:".. v)
			elseif v > 0 then
				BuyMerchantItem(GQ.CheckVendor(k), v)
			end
		end
		GQ.step = 0
	elseif GQ.step > 0 then
		return false
   end
   
end

function GQ.StepCheck()
	GQ.step = 1
   if GQ.step == 1 then
      if GQ.convert[45624] == 0 then
         GQ.step = 2
      end
	elseif GQ.step == 2 then
		if GQ.convert[40753] == 0 then
		  GQ.step = 3
		end
	elseif GQ.step == 3 then
		if GQ.convert[40752] == 0 then
		  GQ.step = 4
		end
	end
end

function GQ.Shopping()
	GemQueueForm:Hide()
	GemQueueProcess:Show()

	GQ.frame:RegisterEvent("MERCHANT_SHOW")
	GQ.frame:RegisterEvent("MERCHANT_CLOSED")
	GQ.frame:SetScript("OnEvent", GQ.OnEvent)
	
	GemQueueProcessVendorLabel:SetText(GQ.vendors[GQ.step])
end

function GQ.OnEvent()
	if(event=="MERCHANT_SHOW") then
		GQ.frame:SetScript("OnUpdate", GQ.OnUpdate)
	elseif (event=="MERCHANT_CLOSED") then
		if GQ.step == 0 then
			GQ.Reset()
			GQ.Refresh()
			GQ.frame:SetScript("OnEvent", nil);
			GQ.frame:UnregisterEvent("MERCHANT_SHOW")
			GQ.frame:RegisterEvent("MERCHANT_CLOSED")
			GemQueueProcess:Hide()
		end
	end
end

function GQ.OnUpdate()
	GemQueueProcessVendorLabel:SetText(GQ.vendors[GQ.step])
	if GQ.Buy() == false then 
		GQ.frame:SetScript("OnUpdate", nil)
	end
	GemQueueProcessVendorLabel:SetText(GQ.vendors[GQ.step])
	if GQ.step == 0 then
		GQ.frame:SetScript("OnUpdate", nil)
		GemQueueProcess:Hide()
	end
end
